local Class = require 'library.middleclass'

local List = Class('List')

function List:initialize(default)
    self.content = default or {}
end

function List:forEach(cb)
    for i, v in ipairs(self.content) do
        cb(i, v)
    end
end

function List:add(element)
    table.insert(self.content, element)
end

function List:addRange(tbl)
    for i, v in ipairs(tbl) do
        self:add(v)
    end
end

function List:remove(index)
    table.remove(self.content, index)
end

function List:removeAll(pred)
    for i, v in ipairs(self.content) do
        if pred(v) then
            self:remove(i)
        end
    end
end

function List:clear()
    self.content = {}
end

--[[
function List:__index(key)
    return self.content[key]
end

function List:__newIndex(key, value)
    self.content[key] = value
end
]]--

return List