local game = require('game'):new()

local callbacks = {"load", "update"}

for k in pairs(love.handlers) do
    callbacks[#callbacks + 1] = k
end


for _, c in ipairs(callbacks) do
    love[c] = function(...)
        game[c](...)
    end
end

--  We have to call the internal draw since it has to apply
--  transformations first before actually calling the
--  class' supplied draw function

function love.draw()
    game:_draw()
end